///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Created by DimasTheDriver on June/8/2011                                       //
// Part of 'Unity: Throttle Controller' post.                          			 //
// Available at:     http://www.41post.com/?p=4073                              //
/////////////////////////////////////////////////////////////////////

using UnityEngine;
using System.Collections;

public class ThrottleController : MonoBehaviour 
{
	//The game object's Transform
	private Transform goTransform;
	
	//the throttle increment to the current velocity
	private float increment=0.0f;
	//this variable stores the vertical axis values
	private float vertAxis=0.0f;
	//the throttle
	private float throttle =0.0f;
	
	void Awake () 
	{
		//get this game object's Transform
		goTransform = this.GetComponent<Transform>();
	}
	
	void Update () 
	{
		//Get the vertical input value and store it at the vertAxis variable
		vertAxis = Input.GetAxis("Vertical");
		
		//change the 'increment' value based on the vertical input
		if(vertAxis>0)
		{
			increment = 0.05f;
		}
		else if(vertAxis<0)
		{
			increment = -0.05f;
		}

		//after releasing the vertical axis, add the increment the throttle
		if(Input.GetButtonUp("Vertical"))
		{
			throttle = throttle+increment;
		}
	
		//set the throttle limit between -0.05f (reverse) and 0.25f (max speed)
		throttle=Mathf.Clamp(throttle, -0.05f,0.25f);
		
		//translates the game object based on the throttle
		goTransform.Translate(throttle * Vector3.forward);
		
		//rotates the game object, based on horizontal input
		goTransform.Rotate(Vector3.up * Input.GetAxis("Horizontal"));
	}
	
	void OnGUI()
	{
		//Render the Instructions
		GUI.Label(new Rect(20,20,350,20),"Use WASD or the arrows keys to control the box.");
		
		//Render the throttle speed
		if(throttle==0.25f)
		{
			GUI.Label(new Rect(20,40,200,20),"Throttle: " + throttle.ToString("n2") + " (max)");
		}
		else if(throttle==-0.05f)
		{
			GUI.Label(new Rect(20,40,200,20),"Throttle: " + throttle.ToString("n2")+ " (reverse)");
		}
		else
		{
			GUI.Label(new Rect(20,40,200,20),"Throttle: " + throttle.ToString("n2"));
		}
	}
	
	
}
